"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const package_is_installable_1 = require("@pnpm/package-is-installable");
const read_importer_manifest_1 = require("@pnpm/read-importer-manifest"), utils = read_importer_manifest_1;
const pnpmPkgJson_1 = require("./pnpmPkgJson");
async function readImporterManifest(importerDir) {
    const { fileName, manifest, writeImporterManifest } = await read_importer_manifest_1.default(importerDir);
    package_is_installable_1.default(importerDir, manifest, {
        engineStrict: true,
        optional: false,
        pnpmVersion: pnpmPkgJson_1.default.version,
        prefix: importerDir,
    });
    return { fileName, manifest, writeImporterManifest };
}
exports.default = readImporterManifest;
async function readImporterManifestOnly(importerDir) {
    const manifest = await utils.readImporterManifestOnly(importerDir);
    package_is_installable_1.default(importerDir, manifest, {
        engineStrict: true,
        optional: false,
        pnpmVersion: pnpmPkgJson_1.default.version,
        prefix: importerDir,
    });
    return manifest;
}
exports.readImporterManifestOnly = readImporterManifestOnly;
async function tryReadImporterManifest(importerDir) {
    const { fileName, manifest, writeImporterManifest } = await utils.tryReadImporterManifest(importerDir);
    if (!manifest)
        return { fileName, manifest, writeImporterManifest };
    package_is_installable_1.default(importerDir, manifest, {
        engineStrict: true,
        optional: false,
        pnpmVersion: pnpmPkgJson_1.default.version,
        prefix: importerDir,
    });
    return { fileName, manifest, writeImporterManifest };
}
exports.tryReadImporterManifest = tryReadImporterManifest;
